Index: s390-tools-sles11/iucvterm/include/iucvterm/functions.h
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/include/iucvterm/functions.h
@@ -0,0 +1,74 @@
+/*
+ * iucvtty / iucvconn - IUCV Terminal Applications
+ *
+ * Definition of common functions
+ *
+ * Copyright IBM Corp. 2008
+ * Author(s): Hendrik Brueckner <brueckner@linux.vnet.ibm.com>
+ */
+#ifndef __FUNCTIONS_H_
+#define __FUNCTIONS_H_
+
+#include <unistd.h>
+
+#include "af_iucv.h"
+#include "inttypes.h"
+#include "iucvterm/config.h"
+#include "iucvterm/proto.h"
+
+
+#define min(a,b)		((a) < (b) ? (a) : (b))
+#define max(a,b)		((a) > (b) ? (a) : (b))
+
+/* Message buffer: message header + 4096 bytes of data */
+#define MSG_BUFFER_SIZE		(MSG_DATA_OFFSET + (4096))
+
+/* Error macros */
+#define print_error(s)		program_error(PRG_COMPONENT, (s))
+#define iucvtty_error(c)	iucv_msg_error(PRG_COMPONENT, (c))
+
+/* Error codes */
+/* Unable to fork new process */
+#define ERR_FORK			105
+/* Cannot execute login program  */
+#define ERR_CANNOT_EXEC_LOGIN		106
+/* Cannot set up terminal as a login terminal */
+#define ERR_SETUP_LOGIN_TTY		107
+/* Client (vm guest) is not authorized */
+#define ERR_NOT_AUTHORIZED		110
+
+
+extern int iucvtty_handle_req(int);
+
+extern int iucvtty_socket(struct sockaddr_iucv *,
+			  const char *, const char *);
+
+extern int iucvtty_tx_termenv(int, char *);
+extern int iucvtty_rx_termenv(int, void *, size_t);
+extern int iucvtty_tx_winsize(int, int);
+extern int iucvtty_tx_data(int, int, struct iucvtty_msg *, size_t);
+extern int iucvtty_tx_error(int, uint32_t);
+extern int iucvtty_copy_data(int, struct iucvtty_msg *);
+extern int iucvtty_read_data(int, struct iucvtty_msg *, size_t);
+
+extern int iucvtty_read_msg(int, struct iucvtty_msg *, size_t, size_t *);
+extern int iucvtty_write_msg(int, struct iucvtty_msg *);
+extern void iucvtty_skip_msg_residual(int, size_t *);
+
+extern ssize_t __write(int, const void*, size_t);
+
+extern int strmatch(const char *, const char *);
+extern int is_regex_valid(const char *);
+extern int is_client_allowed(const char *, const struct iucvtty_cfg *);
+extern void userid_cpy(char [8], const char [8]);
+
+extern void iucv_msg_error(const char *, uint32_t);
+extern void program_error(const char *, const char *);
+
+/* Audit/session log */
+extern int open_session_log(const char *);
+extern ssize_t write_session_log(const void*, size_t);
+extern void write_session_info(const char *, ...);
+extern void close_session_log(void);
+
+#endif /* __FUNCTIONS_H_ */
Index: s390-tools-sles11/iucvterm/include/iucvterm/gettext.h
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/include/iucvterm/gettext.h
@@ -0,0 +1,74 @@
+/*
+ * iucvtty / iucvconn - IUCV Terminal Applications
+ *
+ * National language support (NLS) functions
+ *
+ * Copyright IBM Corp. 2008
+ * Author(s): Hendrik Brueckner <brueckner@linux.vnet.ibm.com>
+ */
+#ifndef __IUCVTTY_GETTEXT_H_
+#define __IUCVTTY_GETTEXT_H_
+
+#ifdef USE_NLS
+#	include <locale.h>
+#	include <libintl.h>
+#endif
+
+
+/* Gettext constants (should be supplied from Makefile) */
+#ifndef GETTEXT_TEXTDOMAIN
+#	define GETTEXT_TEXTDOMAIN	"iucvterm"
+#endif
+#ifndef GETTEXT_NLS_PATH
+#	define GETTEXT_NLS_PATH		"/usr/share/locale"
+#endif
+
+
+/* Gettext macros */
+#ifdef USE_NLS
+#	define _(translatable)		gettext(translatable)
+#else
+#	define _(translatable)		(translatable)
+#endif
+
+#define N_(translatable)		(translatable)
+
+
+
+/**
+ * gettext_setup_locale() - Init gettext text domain using a specific locale
+ * @locale:	Locale to be set.
+ *
+ * The function sets the program locale for LC_MESSAGES and then initializes
+ * gettext.
+ *
+ * The @locale parameter is directly passed to the setlocale() function.
+ * If @locale is "", LC_MESSAGES is set according to the environment variable.
+ */
+static inline int gettext_init_locale(const char *locale)
+{
+#ifdef USE_NLS
+	if (setlocale(LC_MESSAGES, locale) == NULL)
+		return -1;
+	if (bindtextdomain(GETTEXT_TEXTDOMAIN, GETTEXT_NLS_PATH) == NULL)
+		return -1;
+	if (textdomain(GETTEXT_TEXTDOMAIN) == NULL)
+		return -1;
+#endif
+	return 0;
+}
+
+/**
+ * gettext_setup() - Initialize gettext text domain
+ *
+ * Calls gettext_setup_locale() with "" as locale parameter value.
+ */
+static inline int gettext_init(void)
+{
+#ifdef USE_NLS
+	return gettext_init_locale("");
+#else
+	return 0;
+#endif
+}
+#endif /* __IUCVTTY_GETTEXT_H_ */
Index: s390-tools-sles11/iucvterm/include/iucvterm/proto.h
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/include/iucvterm/proto.h
@@ -0,0 +1,108 @@
+/*
+ * iucvtty / iucvconn - IUCV Terminal Applications
+ *
+ * Structure and function definitions for the IUCV terminal message protocol
+ *
+ * Copyright IBM Corp. 2008
+ * Author(s): Hendrik Brueckner <brueckner@linux.vnet.ibm.com>
+ */
+#ifndef __IUCVTTY_PROTO_H_
+#define __IUCVTTY_PROTO_H_
+
+#include <stdint.h>
+#include <string.h>
+
+
+/* Standard macros      */
+#ifndef max
+#	define max(a, b)       ((a) > (b) ? (a) : (b))
+#endif
+#ifndef min
+#	define min(a, b)       ((a) < (b) ? (a) : (b))
+#endif
+#ifndef offsetof
+#	define offsetof(type, member) ((size_t) &((type *)0)->member)
+#endif
+
+/* Packet version magic */
+#define MSG_VERSION		0x02
+/* Message types */
+#define MSG_TYPE_ERROR		0x01	/* Error message. */
+#define MSG_TYPE_TERMENV	0x02	/* Terminal environment variable. */
+#define MSG_TYPE_TERMIOS	0x04	/* Terminal IO struct update. */
+#define MSG_TYPE_WINSIZE	0x08	/* Terminal window size update. */
+#define MSG_TYPE_DATA		0x10	/* Terminal data. */
+
+
+struct iucvtty_msg {
+	uint8_t		version;	/* Message version */
+	uint8_t		type;		/* Message type */
+	uint16_t	datalen;	/* Number of bytes in payload */
+	uint8_t		data[];		/* Payload buffer */
+} __attribute__((packed));
+#define MSG_DATA_OFFSET		(offsetof(struct iucvtty_msg, data))
+#define msg_size(m)		(MSG_DATA_OFFSET + (m)->datalen)
+
+/**
+ * msg_cpy_from() - Copy data to message
+ * @msg:	IUCV terminal message
+ * @src:	Pointer to source data buffer
+ * @len:	Length of source data buffer
+ *
+ * Copies @len bytes from @src to the message data buffer. The caller must
+ * ensure not to overwrite the message data buffer.
+ * Finally, the message datalen is set to @len
+ */
+static inline void msg_cpy_from(struct iucvtty_msg *msg, const void *src,
+				  size_t len)
+{
+	memcpy(msg->data, src, len);
+	msg->datalen = len;
+}
+
+/**
+ * msg_cpy_to() - Copy data from a message
+ * @msg:	IUCV terminal message
+ * @dst:	Destination buffer
+ * @len:	Destination buffer length.
+ *
+ * Copies up to min(@len, message datalen) number of bytes from the IUCV
+ * terminal message to the destination buffer.
+ */
+static inline void msg_cpy_to(const struct iucvtty_msg *msg, void *dst,
+				size_t len)
+{
+	memcpy(dst, msg->data, min(msg->datalen, len));
+}
+
+/**
+ * msg_alloc() - Allocates a new iucv terminal message.
+ * @type:	Message type
+ * @size:	Message data size
+ *
+ * The function allocates a new iucv terminal message with the given data size
+ * @size. (The total message size is @size plus MSG_DATA_OFFSET.)
+ * The new message is initialized with the specific @type.
+ */
+static inline struct iucvtty_msg *msg_alloc(uint8_t type, uint16_t size)
+{
+	struct iucvtty_msg *m;
+
+	m = malloc(size + MSG_DATA_OFFSET);
+	if (m != NULL) {
+		m->version = MSG_VERSION;
+		m->type    = type;
+		m->datalen = size;
+	}
+	return m;
+}
+
+/**
+ * msg_free() - free an allocated iucv tty message
+ */
+static inline void msg_free(struct iucvtty_msg *m)
+{
+	free(m);
+}
+
+#endif /* __IUCVTTY_PROTO_H_ */
Index: s390-tools-sles11/iucvterm/po/Makefile
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/po/Makefile
@@ -0,0 +1,57 @@
+#! /usr/bin/make -f
+#
+# This Makefile creates a message.po template for translation input.
+#
+# To create a localized message.po file from the template, run
+# 	msginit -i progname.pot -l de_DE # --no-translator
+#
+# To finally create the binary message.mo file, run
+# 	msgfmt de.po -o /usr/share/locale/de/LC_MESSAGES/progname.mo
+#
+
+#include ../../common.mak
+
+
+ifndef GETTEXT_TEXTDOMAIN
+GETTEXT_TEXTDOMAIN = iucvterm
+endif
+
+XGETTEXT = xgettext
+XGETTEXT_ARGS = --keyword=print_error
+POTFILES = POTFILES.in
+
+
+all: $(GETTEXT_TEXTDOMAIN).pot
+
+check:
+
+install:
+
+clean:
+	-rm -f $(GETTEXT_TEXTDOMAIN).pot
+
+$(GETTEXT_TEXTDOMAIN).pot:
+	@$(XGETTEXT) --default-domain=$(GETTEXT_TEXTDOMAIN) --directory='..' \
+		--add-comments --keyword=_ --keyword=N_ \
+		--flag=g_strdup_printf:1:c-format \
+		--flag=g_string_printf:2:c-format \
+		--flag=g_string_append_printf:2:c-format \
+		--flag=g_error_new:3:c-format \
+		--flag=g_set_error:4:c-format \
+		--flag=g_markup_printf_escaped:1:c-format \
+		--flag=g_log:3:c-format \
+		--flag=g_print:1:c-format \
+		--flag=g_printerr:1:c-format \
+		--flag=g_printf:1:c-format \
+		--flag=g_fprintf:2:c-format \
+		--flag=g_sprintf:2:c-format \
+		--flag=g_snprintf:3:c-format \
+		--flag=g_scanner_error:2:c-format \
+		--flag=g_scanner_warn:2:c-format \
+		--files-from=$(POTFILES) $(XGETTEXT_ARGS) \
+	&& test ! -f $(GETTEXT_TEXTDOMAIN).po \
+		|| ( rm -f $(GETTEXT_TEXTDOMAIN).pot \
+			&& mv $(GETTEXT_TEXTDOMAIN).po $(GETTEXT_TEXTDOMAIN).pot )
+
+
+.PHONY: install clean $(GETTEXT_TEXTDOMAIN).pot
Index: s390-tools-sles11/iucvterm/po/POTFILES.in
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/po/POTFILES.in
@@ -0,0 +1,4 @@
+src/iucvconn.c
+src/functions.c
+src/iucvtty.c
+src/getopt.c
Index: s390-tools-sles11/iucvterm/src/Makefile
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/src/Makefile
@@ -0,0 +1,33 @@
+#! /usr/bin/make -f
+
+include ../../common.mak
+
+ifndef GETTEXT_TEXTDOMAIN
+GETTEXT_TEXTDOMAIN = iucvterm
+endif
+
+CPPFLAGS += -I../include -I../../include
+CPPFLAGS += -DUSE_NLS -DGETTEXT_TEXTDOMAIN=\"$(GETTEXT_TEXTDOMAIN)\"
+#CPPFLAGS += -D__DEBUG__
+
+PROGRAMS = iucvconn iucvtty
+
+all: $(PROGRAMS)
+check:
+install: strip
+	for prg in $(PROGRAMS); do \
+	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 $$prg $(USRBINDIR) ; \
+	done
+
+strip: $(PROGRAMS)
+	$(STRIP) $^
+
+clean:
+	-rm -f *.o $(PROGRAMS)
+
+iucvconn: iucvconn.o getopt.o auditlog.o functions.o
+iucvtty: LDLIBS = -lutil
+iucvtty: iucvtty.o getopt.o auditlog.o functions.o
+
+
+.PHONY: install clean
Index: s390-tools-sles11/iucvterm/src/auditlog.c
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/src/auditlog.c
@@ -0,0 +1,207 @@
+/*
+ * iucvtty / iucvconn - IUCV Terminal Applications
+ *
+ * Functions for session logging/auditing.
+ * The session log and timing data files adhere to the format
+ * described in script(1).
+ *
+ * Copyright IBM Corp. 2008
+ * Author(s): Hendrik Brueckner <brueckner@linux.vnet.ibm.com>
+ */
+#include <errno.h>
+#include <fcntl.h>
+#include <stdarg.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <sys/time.h>
+#include <string.h>
+#include <time.h>
+#include <unistd.h>
+
+#include "iucvterm/functions.h"
+
+#define OPEN_FILEMODE		(O_WRONLY | O_CREAT | O_EXCL)
+#define OPEN_FILEMASK		(S_IRUSR  | S_IWUSR | S_IRGRP)
+
+static int script_fd   = -1;		/* fd of typescript file  */
+static int timing_fd   = -1;		/* fd of timing data file */
+static FILE *info_file = NULL;		/* FILE of info file      */
+static struct timeval last_tv;		/* tv to calculate timing */
+
+
+/**
+ * print_on_time() - Append formatted time string to a message.
+ * @prefix:	message
+ *
+ * Returns a new buffer starting with @prefix and appends
+ * a formatted string representation of the current time.
+ * Returns NULL if memory allocation has failed.
+ *
+ * The caller must free the returned buffer after use.
+ */
+static char *print_on_time(const char *prefix)
+{
+	char *buf = malloc(64 + strlen(prefix) + 1);
+	time_t t  = time(NULL);
+
+	if (buf != NULL) {
+		if (t == (time_t) -1)
+			sprintf(buf, "%s\n", prefix);
+		else {
+			sprintf(buf, "%s on ", prefix);
+			ctime_r(&t, buf + strlen(prefix) + 4);
+		}
+	}
+	return buf;
+}
+
+/**
+ * write_session_info() - Write data to the session info file
+ * @format:	Format string, shall not be NULL
+ *
+ * Writes informational messages to the session info file.
+ * The info message is prefixed with a timestamp as returned by the
+ * time(2) syscall.
+ */
+void write_session_info(const char *format, ...)
+{
+	va_list ap;
+
+	if (info_file == NULL)
+		return;
+
+	fprintf(info_file, "%lu ", time(NULL));
+	va_start(ap, format);
+	vfprintf(info_file, format, ap);
+	va_end(ap);
+	if (strrchr(format, '\n') == NULL)
+		fprintf(info_file, "\n");
+}
+
+/**
+ * write_session_log() - Write session data to the session log file
+ * @buf:	Pointer to a buffer with data to log
+ * @len:	Copy up to @len bytes from @buf
+ *
+ * The routines writes up to @len bytes of data from buffer @buf to
+ * the session transcript; write appropriate timing data to the timing
+ * file.
+ */
+ssize_t write_session_log(const void* buf, size_t len)
+{
+	ssize_t rc;
+	int count;
+	char data[64] = "";
+	struct timeval curr_tv;
+	long time_diff;
+
+	/* immediately return if there is no fd to write to */
+	if (script_fd == -1)
+		return -1;
+
+	rc = __write(script_fd, buf, len);
+	if (rc < 0)
+		return rc;
+
+	/* calculate delay and write timing info */
+	if (gettimeofday(&curr_tv, NULL))
+		time_diff = 1000000;	/* one second (in usecs) */
+	else {
+		time_diff = (curr_tv.tv_sec  - last_tv.tv_sec) * 1000000 +
+			     curr_tv.tv_usec - last_tv.tv_usec;
+		last_tv   = curr_tv;	/* reset last timeval */
+	}
+
+	count = sprintf(data, "%.6f %zu\n",
+			(double) time_diff / (double) 1000000, len);
+	rc = __write(timing_fd, data, (count < 0) ? 0 : count );
+	if (rc < 0)
+		return rc;
+
+	return 0;
+}
+
+/**
+ * close_session_log() - Close session logging
+ *
+ * The routine writes a trailer to the session log file and
+ * closes the session log, timing and info file descriptor.
+ */
+void close_session_log(void)
+{
+	char *trailer;
+
+	if (script_fd > 0) {
+		trailer = print_on_time("Script done");
+		if (trailer != NULL) {
+			__write(script_fd, trailer, strlen(trailer));
+			write_session_info(trailer);
+			free(trailer);
+		}
+		close(script_fd);
+	}
+	if (timing_fd > 0)
+		close(timing_fd);
+	if (info_file != NULL)
+		fclose(info_file);
+}
+
+/**
+ * open_session_log() - Open session logging
+ * @filepath:	File path to the session transcript
+ *
+ * Opens the session, timing and info log file.
+ * If the session specified by @filepath already exists; or one of the
+ * files cannot be opened successfully, return an error.
+ */
+int open_session_log(const char *filepath)
+{
+	char *buf;
+	int   old_errno;
+	int   info_fd;
+
+	buf = calloc(11 + strlen(filepath), sizeof(char));
+	if (buf == NULL)
+		goto out_no_mem;
+
+	script_fd = open(filepath, OPEN_FILEMODE, OPEN_FILEMASK);
+	if (script_fd == -1)
+		goto out_error_open;
+
+	sprintf(buf, "%s.timing", filepath);
+	timing_fd = open(buf, OPEN_FILEMODE, OPEN_FILEMASK);
+	if (timing_fd == -1)
+		goto out_error_open;
+
+	sprintf(buf, "%s.info", filepath);
+	info_fd = open(buf, OPEN_FILEMODE, OPEN_FILEMASK);
+	if (info_fd == -1)
+		goto out_error_open;
+	info_file = fdopen(info_fd, "w");
+	if (info_file == NULL)
+		goto out_error_open;
+
+	if(gettimeofday(&last_tv, NULL))
+		goto out_error_open;
+
+	free(buf);
+
+	buf = print_on_time("Script started");
+	if (buf != NULL) {
+		__write(script_fd, buf, strlen(buf));
+		write_session_info(buf);
+		free(buf);
+	}
+
+	return 0;
+
+out_error_open:
+	old_errno = errno;	/* preserve errno */
+	free(buf);
+	close_session_log();
+	errno = old_errno;	/* restore errno from failed open call */
+out_no_mem:
+	return -1;
+}
Index: s390-tools-sles11/iucvterm/src/functions.c
===================================================================
--- /dev/null
+++ s390-tools-sles11/iucvterm/src/functions.c
@@ -0,0 +1,519 @@
+/*
+ * iucvtty / iucvconn - IUCV Terminal Applications
+ *
+ * Common functions
+ *
+ * Copyright IBM Corp. 2008, 2009
+ * Author(s): Hendrik Brueckner <brueckner@linux.vnet.ibm.com>
+ */
+#include <errno.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <regex.h>
+#include <sys/ioctl.h>
+#include <sys/socket.h>
+#include <sys/types.h>
+#include <unistd.h>
+
+#include "af_iucv.h"
+#include "iucvterm/config.h"
+#include "iucvterm/gettext.h"
+#include "iucvterm/functions.h"
+#include "iucvterm/proto.h"
+
+
+/* Global program component for iucv terminal tools */
+#define PRG_COMPONENT		"iucvterm"
+
+
+/**
+ * __write() - Write data
+ * @fd:		File descriptor
+ * @buf:	Pointer to data buffer
+ * @len:	Buffer length
+ *
+ * Write @len number of bytes from the buffer @buf to the file
+ * descriptor @fd. The routines handles EINTR and partially writes.
+ * Returns the error code from the underlying write(2) syscall.
+ */
+ssize_t __write(int fd, const void *buf, size_t len)
+{
+	ssize_t rc;
+	size_t  written = 0;
+
+	while (written < len) {
+		rc = write(fd, buf + written, len - written);
+		if (rc == -1 && errno == EINTR)
+			continue;
+		if (rc <= 0)
+			return rc;
+		written += rc;
+	}
+	return written;
+}
+
+#ifdef __DEBUG__
+static void __dump_msg(int fd, const struct iucvtty_msg *m, char dir)
+{
+	write_session_info("%c: (fd=%d) MSG: ver=%02x type=%02x datalen=%u\n",
+			   dir, fd, m->version, m->type, (uint16_t) m->datalen);
+}
+#endif
+
+
+/**
+ * iucvtty_socket() - Creates and return an IUCV socket
+ * @sai:	AF_IUCV socket address structure
+ * @host:	z/VM guest name
+ * @service:	Terminal name passed as additional data to @host after connect
+ *
+ * This function sets up the struct sockaddr_iucv with the specified
+ * VM guest virtual machine and terminal information.
+ * Finally, it returns an AF_IUCV socket.
+ */
+int iucvtty_socket(struct sockaddr_iucv *sai,
+		   const char *host, const char *service)
+{
+	char temp[9];
+
+	memset(sai, 0, sizeof(struct sockaddr_iucv));
+	sai->siucv_family = AF_IUCV;
+
+	if (host != NULL) {
+		snprintf(temp, 9, "%-8s", host);
+		memcpy(sai->siucv_user_id, temp, 8);
+	} else
+		memset(sai->siucv_user_id, ' ', 8);
+
+	if (service != NULL) {
+		snprintf(temp, 9, "%-8s", service);
+		memcpy(sai->siucv_name, temp, 8);
+	} else
+		memset(sai->siucv_user_id, ' ', 8);
+
+	return socket(PF_IUCV, SOCK_STREAM, 0);
+}
+
+/**
+ * iucvtty_tx_termenv() - Send terminal environment variable
+ * @dest:	File descriptor to output data
+ * @dflt:	TERM environment string ('\0' terminated)
+ *
+ * Copy terminal environment variable to destination @dest.
+ */
+int iucvtty_tx_termenv(int dest, char *dflt)
+{
+	struct iucvtty_msg *msg;
+	char *term = getenv("TERM");
+	size_t len;
+	int rc;
+
+	if (term == NULL && dflt != NULL)
+		term = dflt;
+
+	len = 0;
+	if (term != NULL)
+		len = 1 + strlen(term);
+
+	/* Note: The server console tool waits for terminal environment
+	 *       information: the message is sent even if it is empty */
+	msg = msg_alloc(MSG_TYPE_TERMENV, len);
+	if (msg == NULL)
+		return -1;
+	msg_cpy_from(msg, term, len);
+	rc = iucvtty_write_msg(dest, msg);
+	msg_free(msg);
+
+	return rc;
+}
+
+/**
+ * iucvtty_rx_termenv() - Receive terminal environment variable
+ * @fd:		File descriptor to read data from
+ * @buf:	Buffer to store the terminal environment variable
+ * @len:	Size of buffer @buf
+ */
+int iucvtty_rx_termenv(int fd, void *buf, size_t len)
+{
+	int rc;
+	size_t skip;
+	struct iucvtty_msg *msg = msg_alloc(MSG_TYPE_TERMENV, len);
+
+	if (msg == NULL)
+		return -1;
+	skip = 0;
+	rc = iucvtty_read_msg(fd, msg, msg_size(msg), &skip);
+	iucvtty_skip_msg_residual(fd, &skip);
+	if (!rc) {
+		if (msg->datalen == 0)
+			memset(buf, 0, min(1, len));
+		else
+			msg_cpy_to(msg, buf, len);
+	}
+	msg_free(msg);
+	return rc;
+}
+
+/**
+ * iucvtty_tx_data() - Send terminal data
+ * @from:	File descriptor to read data from
+ * @msg:	Pointer to iucv tty message buffer
+ * @len:	Size of message buffer
+ *
+ * This routine reads data from file descriptor @from and stores them in
+ * a data array of the specified iucv tty message @msg. It reads up to
+ * @len - MSG_DATA_OFFSET bytes from fd @from.
+ */
+int iucvtty_read_data(int from, struct iucvtty_msg *msg, size_t len)
+{
+	ssize_t r;
+
+	r = read(from, msg->data, len - MSG_DATA_OFFSET);
+	if (r == -1 && errno == EINTR)	/* REVIEW: loop if EINTR ? */
+		r = read(from, msg->data, len - MSG_DATA_OFFSET);
+	if (r <= 0)
+		return -1;
+	msg->version = MSG_VERSION;
+	msg->type    = MSG_TYPE_DATA;
+	msg->datalen = (uint16_t) r;
+
+	return 0;
+}
+
+/**
+ * iucvtty_tx_data() - Send terminal data
+ * @dest:	File descriptor to send data to
+ * @from:	File descriptor to read data from
+ * @msg:	Pointer to iucv tty message buffer
+ * @len:	Size of message buffer
+ *
+ * This routine reads data from file descriptor @from and stores them in
+ * a data array of the specified iucv tty message @msg. It reads up to
+ * @len - MSG_DATA_OFFSET bytes from fd @from.
+ * Finally, the iucv tty message written to file descriptor @dest.
+ */
+int iucvtty_tx_data(int dest, int from, struct iucvtty_msg *msg, size_t len)
+{
+	if (iucvtty_read_data(from, msg, len))
+		return -1;
+	if (iucvtty_write_msg(dest, msg))
+		return -1;
+	return 0;
+}
+
+/**
+ * iucvtty_tx_winsize() - Send terminal window size information.
+ * @dest:	Destination
+ * @from:	Terminal file descriptor to request winsize
+ *
+ * Sends the terminal window size from terminal file descriptor
+ * @from to the destination @dest.
+ * If the window size is not retrieved, the routine will not fail.
+ * The routine fails if there is a problem sending the window size
+ * to @dest. The return codes are specified by iucvtty_write_msg().
+ */
+int iucvtty_tx_winsize(int dest, int from)
+{
+	int rc;
+	struct iucvtty_msg *msg = msg_alloc(MSG_TYPE_WINSIZE,
+					      sizeof(struct winsize));
+	if (msg == NULL)
+		return -1;
+	rc = 0;
+	if (ioctl(from, TIOCGWINSZ, msg->data) > -1)
+		rc = iucvtty_write_msg(dest, msg);
+	msg_free(msg);
+
+	return rc;
+}
+
+/**
+ * iucvtty_tx_error() - Send an error code
+ * @dest:	Destination
+ * @errCode:	Error code
+ */
+int iucvtty_tx_error(int dest, uint32_t errCode)
+{
+	struct iucvtty_msg *msg;
+	int rc;
+
+	msg = msg_alloc(MSG_TYPE_ERROR, sizeof(errCode));
+	if (msg == NULL)
+		return -1;
+	msg_cpy_from(msg, &errCode, sizeof(errCode));
+	rc = iucvtty_write_msg(dest, msg);
+	msg_free(msg);
+	return rc;
+}
+
+/**
+ * iucvtty_copy_data() - Copy IUCV message data
+ * @dest:	Destination to copy data to
+ * @msg:	IUCV message
+ */
+int iucvtty_copy_data(int dest, struct iucvtty_msg *msg)
+{
+	if (__write(dest, msg->data, msg->datalen) <= 0)
+		return -1;
+	return 0;
+}
+
+/**
+ * iucvtty_skip_msg_residual() - Skip (receive & forget) count number of bytes
+ * @fd:		File descriptor
+ * @residual:	Residual of an iucv tty message received by iucvtty_read_msg()
+ *
+ * See iucvtty_read_msg() for an explanation when to use this routine.
+ * Note: The @residual parameter shall not be NULL.
+ */
+void iucvtty_skip_msg_residual(int fd, size_t *residual)
+{
+	char b;
+	size_t  i;
+
+	if (*residual <= 0)
+		return;
+	for (i = 0; i < *residual; i++)
+		if (read(fd, &b, 1) <= 0)
+			break;
+	*residual = 0;
+}
+
+/**
+ * iucvtty_read_msg() - Read/Receive an IUCV message
+ * @fd:		File descriptor to read from
+ * @msg:	Pointer to IUCV message buffer
+ * @len:	IUCV message data len
+ * @residual:	Status to be used by next call
+ *
+ * The function reads up to @len bytes from file descriptor @fd.
+ * If the received message is larger than @len bytes, the @residual value
+ * is set to the number of bytes remaining.
+ * The function shall then be re-called to create a new message and receive
+ * the next chunk of size @residual; or the remaining characters must be
+ * skipped using the iucvtty_skip_msg() routine.
+ * Note: The @len parameter shall be greater than MSG_DATA_OFFSET.
+ *       The @residual parameter shall not be NULL.
+ */
+int iucvtty_read_msg(int fd, struct iucvtty_msg *msg,
+		     size_t len, size_t *residual)
+{
+	int rc;
+	ssize_t r;		/* number of bytes read from fd */
+
+	if (*residual)
+		len = min(len - MSG_DATA_OFFSET, *residual);
+
+	while (1) {
+		if (*residual) {
+			r = read(fd, msg->data, len);
+			if (r > 0)
+				msg->datalen = r;
+		} else
+			r = read(fd, msg, len);
+
+		if (r == -1 && errno == EINTR)
+			continue;
+		if (r <= 0) {
+			rc = -1;
+			goto out_read_error;
+		}
+
+		break;	/* exit loop for a successful read */
+	}
+#ifdef __DEBUG__
+	if (!*residual)
+		__dump_msg(fd, msg, 'R');
+#endif
+
+	/* (re)calculate next chunk */
+	if (*residual)
+		*residual -= msg->datalen;
+	else
+		if (msg->datalen > (r - MSG_DATA_OFFSET)) {
+			/* calculate pending msg data and update datalen */
+			*residual = msg->datalen - (r - MSG_DATA_OFFSET);
+			msg->datalen = r - MSG_DATA_OFFSET;
+		}
+
+	/* check for a sane message */
+	if (msg->version != MSG_VERSION) {
+		fprintf(stderr, _("%s: %s\n"),
+			PRG_COMPONENT, _("The version of the received data "
+					 "message is not supported\n"));
+		rc = -2;
+		goto out_read_error;
+	}
+
+	rc = 0;
+out_read_error:
+	return rc;
+}
+
+/**
+ * iucvtty_write_msg() - Write/Send IUCV message
+ * @fd:		File descriptor
+ * @msg:	Pointer to IUCV message
+ */
+int iucvtty_write_msg(int fd, struct iucvtty_msg *msg)
+{
+	msg->version = MSG_VERSION;
+
+	if (__write(fd, msg, msg_size(msg)) <= 0)
+		return -1;
+
+#ifdef __DEBUG__
+	__dump_msg(fd, msg, 'S');
+#endif
+	return 0;
+}
+
+
+/**
+ * iucv_msg_error() - Reports an IUCV message error
+ * @comp:	Program component
+ * @errnum:	IUCV message error code
+ */
+void iucv_msg_error(const char *comp, uint32_t errnum)
+{
+	const char *translated;
+
+	switch (errnum) {
+	case ERR_FORK:
+		translated = _("Creating a new process to run the "
+				"login program failed");
+		break;
+	case ERR_CANNOT_EXEC_LOGIN:
+		translated = _("Running the login program failed");
+		break;
+	case ERR_SETUP_LOGIN_TTY:
+		translated = _("Setting up a terminal for user login failed");
+		break;
+	case ERR_NOT_AUTHORIZED:
+		translated = _("The z/VM guest virtual machine is not "
+				"permitted to connect");
+		break;
+	default:
+		translated = _("The specified error code is not known");
+		break;
+	}
+	fprintf(stderr, "%s: %s (%s=%" PRIu32 ")\r\n",
+		comp, translated, _("error code"), errnum);
+}
+
+/**
+ * program_error() - Report an program/syscall error.
+ * @comp:	Program component name
+ * @d:		Error message, subject to gettext translation
+ */
+void program_error(const char *comp, const char *d)
+{
+	fprintf(stderr, _("%s: %s: %s\n"), comp, _(d), strerror(errno));
+}
+
+
+/**
+ * __regerror - Report an error from a previous regex api call
+ * @error:	Error code
+ * @re:		Reference to the used regular expression
+ */
+static inline void __regerror(int error, const regex_t *re)
+{
+	char errbuf[81];
+
+	regerror(error, re, errbuf, 81);
+	fprintf(stderr, _("The regular expression has an error: %s\n"), errbuf);
+	return;
+}
+
+/**
+ * is_regex_valid() - Check if the specified regex is syntactically correct.
+ * @re:		String representation of the regular expression
+ *
+ * Returns zero on success, otherwise -1.
+ */
+int is_regex_valid(const char *re)
+{
+	regex_t regex;
+	int rc;
+
+	if (re == NULL)
+		return -1;
+	rc = regcomp(&regex, re, REG_EXTENDED | REG_ICASE | REG_NOSUB);
+	if (rc) {
+		__regerror(rc, &regex);
+		rc = -1;
+	}
+	regfree(&regex);
+
+	return rc;
+}
+
+/**
+ * strmatch() - Match a string using a regular expression
+ * @str:	String to match
+ * @re:		Regular expression
+ *
+ * Returns zero on success, -1 on error or if @str is NULL; and
+ * 1 if the regular expression did not match the string.
+ */
+int strmatch(const char *str, const char *re)
+{
+	regex_t regex;
+	regmatch_t pmatch[1];
+	size_t nmatch = 0;
+	int rc;
+
+	if (re == NULL)
+		return -1;
+
+	rc = regcomp(&regex, re, REG_EXTENDED | REG_ICASE | REG_NOSUB);
+	if (rc) {
+		__regerror(rc, &regex);
+		regfree(&regex);
+		return -1;
+	}
+
+	rc = regexec(&regex, str, nmatch, pmatch, 0);
+	if (rc == REG_NOMATCH)
+		rc = 1;
+
+	regfree(&regex);
+	return rc;
+}
+
+/**
+ * is_client_allowed() - Check if the client is allowed to connect.
+ * @client:	Client name
+ * @cfg:	Pointer to the IUCV terminal configuration structure
+ *
+ * The return code is identical to strmatch(). The function returns always
+ * zero if client_checking is disabled by the configuration.
+ */
+int is_client_allowed(const char *client, const struct iucvtty_cfg *cfg)
+{
+	if (!cfg->client_check)
+		return 0;
+
+	return strmatch(client, cfg->client_re);
+}
+
+/**
+ * userid_cpy() - Copy z/VM user ID and skip trailing spaces.
+ * @dest:	Destination buffer
+ * @userid:	z/VM user ID
+ */
+void userid_cpy(char dest[9], const char userid[8])
+{
+	ssize_t pos;
+
+	/* find pos of last character (pos 0..7) or -1 if user ID is empty */
+	for (pos = 7; pos >= 0; pos--)
+		if (userid[pos] != ' ')
+			break;
+
+	if (pos >= 0)
+		memcpy(dest, userid, pos + 1);
+	dest[pos + 1] = '\0';
+}
